/*
	$Id: message.h,v 1.1 2000/10/03 18:45:26 syl Exp $

	Copyright (C) 1999, 2000 Syllabub
	Maroontress Fast Software.
*/

#define OPCODE_XIM_CONNECT 1
#define OPCODE_XIM_CONNECT_REPLY 2
#define OPCODE_XIM_DISCONNECT 3
#define OPCODE_XIM_DISCONNECT_REPLY 4
#define OPCODE_XIM_ERROR 20
#define OPCODE_XIM_OPEN 30
#define OPCODE_XIM_OPEN_REPLY 31
#define OPCODE_XIM_CLOSE 32
#define OPCODE_XIM_CLOSE_REPLY 33
#define OPCODE_XIM_REGISTER_TRIGGERKEYS 34
#define OPCODE_XIM_TRIGGER_NOTIFY 35
#define OPCODE_XIM_TRIGGER_NOTIFY_REPLY 36
#define OPCODE_XIM_SET_EVENT_MASK 37
#define OPCODE_XIM_ENCODING_NEGOTIATION 38
#define OPCODE_XIM_ENCODING_NEGOTIATION_REPLY 39
#define OPCODE_XIM_QUERY_EXTENSION 40
#define OPCODE_XIM_QUERY_EXTENSION_REPLY 41
#define OPCODE_XIM_GET_IM_VALUES 44
#define OPCODE_XIM_GET_IM_VALUES_REPLY 45
#define OPCODE_XIM_CREATE_IC 50
#define OPCODE_XIM_CREATE_IC_REPLY 51
#define OPCODE_XIM_DESTROY_IC 52
#define OPCODE_XIM_DESTROY_IC_REPLY 53
#define OPCODE_XIM_SET_IC_VALUES 54
#define OPCODE_XIM_SET_IC_VALUES_REPLY 55
#define OPCODE_XIM_GET_IC_VALUES 56
#define OPCODE_XIM_GET_IC_VALUES_REPLY 57
#define OPCODE_XIM_SET_IC_FOCUS 58
#define OPCODE_XIM_UNSET_IC_FOCUS 59
#define OPCODE_XIM_FORWARD_EVENT 60
#define OPCODE_XIM_SYNC 61
#define OPCODE_XIM_SYNC_REPLY 62
#define OPCODE_XIM_COMMIT 63
#define OPCODE_XIM_RESET_IC 64
#define OPCODE_XIM_RESET_IC_REPLY 65
#define OPCODE_XIM_PREEDIT_START 73
#define OPCODE_XIM_PREEDIT_START_REPLY 74
#define OPCODE_XIM_PREEDIT_DRAW 75
#define OPCODE_XIM_PREEDIT_CARET 76
#define OPCODE_XIM_PREEDIT_CARET_REPLY 77
#define OPCODE_XIM_PREEDIT_DONE 78

typedef struct {
    CARD8 major_opcode;
    CARD8 minor_opcode;
    CARD16 length;
    CARD8 data[0];
} Message;

void InitializeWire(Display *);
void SendIntoWire(Connection *, int, SerializedPacket *, int);
